
# WorkloadConfig

## Properties
Name | Type | Description | Notes
------------ | ------------- | ------------- | -------------
**workloadType** | [**WorkloadTypeEnum**](#WorkloadTypeEnum) |  |  [optional]
**workloadClass** | **String** | workload class, e.g. com.yahoo.ycsb.workloads.CoreWorkload |  [optional]
**maxExecutionTime** | **Integer** | maximal runtime in seconds, set 0 for unlimited |  [optional]
**threadCount** | **Integer** | number of threads per client |  [optional]
**recordCount** | **Integer** | number of records to load/operate on |  [optional]
**insertStart** | **Integer** | only for parallel insert workloads, index to start with |  [optional]
**insertCount** | **Integer** | only for parallel insert workloads, total number of inserts by this client |  [optional]
**operations** | **Integer** | total amount of operations to execute |  [optional]
**targetOps** | **Integer** | target operations per seconds per thread (if DB is able to execute) |  [optional]
**fieldCount** | **Integer** | he number of fields in a record |  [optional]
**fieldLength** | **Integer** | the size of each field in Kb |  [optional]
**readAllFileds** | **Boolean** | should reads read all fields (true) or just one (false) |  [optional]
**readModifyWriteProportion** | **Integer** | what proportion of operations should be read a record, modify it, write it back |  [optional]
**requestdistribution** | [**RequestdistributionEnum**](#RequestdistributionEnum) | what distribution should be used to select the records to operate on – uniform, zipfian or latest |  [optional]
**scanLengthDistribution** | [**ScanLengthDistributionEnum**](#ScanLengthDistributionEnum) | what distribution should be used to choose the number of records to scan, for each scan, between 1 and maxscanlength (default: uniform) |  [optional]
**insertOrder** | [**InsertOrderEnum**](#InsertOrderEnum) | should records be inserted in order by key (“ordered”), or in hashed order (“hashed”) |  [optional]
**readProportion** | **Double** | proportion of operations should be reads |  [optional]
**updateProportion** | **Double** | proportion of operations should be updates |  [optional]
**insertProportion** | **Double** | proportion of operations should be inserts |  [optional]
**scanProportion** | **Double** | proportion of operations should be scans |  [optional]
**maxScanLength** | **Integer** | for scans, what is the maximum number of records to scan (default 1000) |  [optional]
**coreWorkloadInsertionRetryLimit** | **Integer** | umber of attempts for any failed insert operation (default 0) |  [optional]
**coreWorkloadInsertionRetryInterval** | **Integer** | interval between retries, in seconds (default 3) |  [optional]


<a name="WorkloadTypeEnum"></a>
## Enum: WorkloadTypeEnum
Name | Value
---- | -----
LOAD | &quot;LOAD&quot;
RUN | &quot;RUN&quot;


<a name="RequestdistributionEnum"></a>
## Enum: RequestdistributionEnum
Name | Value
---- | -----
UNIFORM | &quot;UNIFORM&quot;
ZIPFIAN | &quot;ZIPFIAN&quot;
LATEST | &quot;LATEST&quot;


<a name="ScanLengthDistributionEnum"></a>
## Enum: ScanLengthDistributionEnum
Name | Value
---- | -----
UNIFORM | &quot;UNIFORM&quot;
ZIPFIAN | &quot;ZIPFIAN&quot;


<a name="InsertOrderEnum"></a>
## Enum: InsertOrderEnum
Name | Value
---- | -----
ORDERED | &quot;ORDERED&quot;
HASHED | &quot;HASHED&quot;



