/*
 * Workload API
 * Benchmark your distributed DBMS with a specific workload
 *
 * OpenAPI spec version: 0.0.1
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package de.uulm.omi.cloudiator.dbms.evaluator.model;

import java.util.Objects;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.io.IOException;
import java.math.BigDecimal;

/**
 * TSBSQueryConfig
 */
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2019-11-25T12:08:48.669+01:00")
public class TSBSQueryConfig {
  @SerializedName("usecase")
  private String usecase = null;

  @SerializedName("seed")
  private BigDecimal seed = null;

  @SerializedName("scale")
  private BigDecimal scale = null;

  @SerializedName("startTime")
  private String startTime = null;

  @SerializedName("endTime")
  private String endTime = null;

  @SerializedName("queries")
  private BigDecimal queries = null;

  @SerializedName("queryType")
  private String queryType = null;

  /**
   * specifies the data format for the selected DBMS
   */
  @JsonAdapter(FormatEnum.Adapter.class)
  public enum FormatEnum {
    INFLUX("influx"),
    
    TIMESCALEDB("timescaledb"),
    
    MONGODB("mongodb");

    private String value;

    FormatEnum(String value) {
      this.value = value;
    }

    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    public static FormatEnum fromValue(String text) {
      for (FormatEnum b : FormatEnum.values()) {
        if (String.valueOf(b.value).equals(text)) {
          return b;
        }
      }
      return null;
    }

    public static class Adapter extends TypeAdapter<FormatEnum> {
      @Override
      public void write(final JsonWriter jsonWriter, final FormatEnum enumeration) throws IOException {
        jsonWriter.value(enumeration.getValue());
      }

      @Override
      public FormatEnum read(final JsonReader jsonReader) throws IOException {
        String value = jsonReader.nextString();
        return FormatEnum.fromValue(String.valueOf(value));
      }
    }
  }

  @SerializedName("format")
  private FormatEnum format = null;

  public TSBSQueryConfig usecase(String usecase) {
    this.usecase = usecase;
    return this;
  }

   /**
   * TODO
   * @return usecase
  **/
  @ApiModelProperty(example = "cpu-only", value = "TODO")
  public String getUsecase() {
    return usecase;
  }

  public void setUsecase(String usecase) {
    this.usecase = usecase;
  }

  public TSBSQueryConfig seed(BigDecimal seed) {
    this.seed = seed;
    return this;
  }

   /**
   * By supplying the same seed to the generation programs, each database is loaded with identical data and queried using identical queries.
   * @return seed
  **/
  @ApiModelProperty(example = "123.0", value = "By supplying the same seed to the generation programs, each database is loaded with identical data and queried using identical queries.")
  public BigDecimal getSeed() {
    return seed;
  }

  public void setSeed(BigDecimal seed) {
    this.seed = seed;
  }

  public TSBSQueryConfig scale(BigDecimal scale) {
    this.scale = scale;
    return this;
  }

   /**
   * TODO
   * @return scale
  **/
  @ApiModelProperty(example = "1000.0", value = "TODO")
  public BigDecimal getScale() {
    return scale;
  }

  public void setScale(BigDecimal scale) {
    this.scale = scale;
  }

  public TSBSQueryConfig startTime(String startTime) {
    this.startTime = startTime;
    return this;
  }

   /**
   * starting timestamp for generating the data
   * @return startTime
  **/
  @ApiModelProperty(example = "2016-01-01T00:00:00Z", value = "starting timestamp for generating the data")
  public String getStartTime() {
    return startTime;
  }

  public void setStartTime(String startTime) {
    this.startTime = startTime;
  }

  public TSBSQueryConfig endTime(String endTime) {
    this.endTime = endTime;
    return this;
  }

   /**
   * ending timestamp for generating the data
   * @return endTime
  **/
  @ApiModelProperty(example = "2016-01-04T00:00:00Z", value = "ending timestamp for generating the data")
  public String getEndTime() {
    return endTime;
  }

  public void setEndTime(String endTime) {
    this.endTime = endTime;
  }

  public TSBSQueryConfig queries(BigDecimal queries) {
    this.queries = queries;
    return this;
  }

   /**
   * TODO
   * @return queries
  **/
  @ApiModelProperty(example = "20.0", value = "TODO")
  public BigDecimal getQueries() {
    return queries;
  }

  public void setQueries(BigDecimal queries) {
    this.queries = queries;
  }

  public TSBSQueryConfig queryType(String queryType) {
    this.queryType = queryType;
    return this;
  }

   /**
   * specifies one of the supported query type
   * @return queryType
  **/
  @ApiModelProperty(example = "single-groupby-1-1-1", value = "specifies one of the supported query type")
  public String getQueryType() {
    return queryType;
  }

  public void setQueryType(String queryType) {
    this.queryType = queryType;
  }

  public TSBSQueryConfig format(FormatEnum format) {
    this.format = format;
    return this;
  }

   /**
   * specifies the data format for the selected DBMS
   * @return format
  **/
  @ApiModelProperty(example = "influx", value = "specifies the data format for the selected DBMS")
  public FormatEnum getFormat() {
    return format;
  }

  public void setFormat(FormatEnum format) {
    this.format = format;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    TSBSQueryConfig tsBSQueryConfig = (TSBSQueryConfig) o;
    return Objects.equals(this.usecase, tsBSQueryConfig.usecase) &&
        Objects.equals(this.seed, tsBSQueryConfig.seed) &&
        Objects.equals(this.scale, tsBSQueryConfig.scale) &&
        Objects.equals(this.startTime, tsBSQueryConfig.startTime) &&
        Objects.equals(this.endTime, tsBSQueryConfig.endTime) &&
        Objects.equals(this.queries, tsBSQueryConfig.queries) &&
        Objects.equals(this.queryType, tsBSQueryConfig.queryType) &&
        Objects.equals(this.format, tsBSQueryConfig.format);
  }

  @Override
  public int hashCode() {
    return Objects.hash(usecase, seed, scale, startTime, endTime, queries, queryType, format);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class TSBSQueryConfig {\n");
    
    sb.append("    usecase: ").append(toIndentedString(usecase)).append("\n");
    sb.append("    seed: ").append(toIndentedString(seed)).append("\n");
    sb.append("    scale: ").append(toIndentedString(scale)).append("\n");
    sb.append("    startTime: ").append(toIndentedString(startTime)).append("\n");
    sb.append("    endTime: ").append(toIndentedString(endTime)).append("\n");
    sb.append("    queries: ").append(toIndentedString(queries)).append("\n");
    sb.append("    queryType: ").append(toIndentedString(queryType)).append("\n");
    sb.append("    format: ").append(toIndentedString(format)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

