/*
 * Workload API
 * Benchmark your distributed DBMS with a specific workload
 *
 * OpenAPI spec version: 0.0.1
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package de.uulm.omi.dbms.workload.api;

import de.uulm.omi.dbms.workload.client.ApiCallback;
import de.uulm.omi.dbms.workload.client.ApiClient;
import de.uulm.omi.dbms.workload.client.ApiException;
import de.uulm.omi.dbms.workload.client.ApiResponse;
import de.uulm.omi.dbms.workload.client.Configuration;
import de.uulm.omi.dbms.workload.client.Pair;
import de.uulm.omi.dbms.workload.client.ProgressRequestBody;
import de.uulm.omi.dbms.workload.client.ProgressResponseBody;

import com.google.gson.reflect.TypeToken;

import java.io.IOException;


import de.uulm.omi.cloudiator.dbms.evaluator.model.Error;
import java.io.File;
import de.uulm.omi.cloudiator.dbms.evaluator.model.TPCCWorkload;
import de.uulm.omi.cloudiator.dbms.evaluator.model.TSBSWorkload;
import de.uulm.omi.cloudiator.dbms.evaluator.model.WorkloadProcessInstance;
import de.uulm.omi.cloudiator.dbms.evaluator.model.WorkloadProcessSubmissionError;
import de.uulm.omi.cloudiator.dbms.evaluator.model.YCSBWorkload;

import java.lang.reflect.Type;

public class DefaultApi {
    private ApiClient apiClient;

    public DefaultApi() {
        this(Configuration.getDefaultApiClient());
    }

    public DefaultApi(ApiClient apiClient) {
        this.apiClient = apiClient;
    }

    public ApiClient getApiClient() {
        return apiClient;
    }

    public void setApiClient(ApiClient apiClient) {
        this.apiClient = apiClient;
    }

    /**
     * Build call for workloadResultGet
     * @param taskId the id of the worklaod execution task, used as prefix for result files (required)
     * @param workloadType workload type of the result file (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call workloadResultGetCall(String taskId, String workloadType, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;

        // create path and map variables
        String localVarPath = "/workload/result";

        java.util.List<Pair> localVarQueryParams = new java.util.ArrayList<Pair>();
        java.util.List<Pair> localVarCollectionQueryParams = new java.util.ArrayList<Pair>();
        if (taskId != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("taskId", taskId));
        if (workloadType != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("workloadType", workloadType));

        java.util.Map<String, String> localVarHeaderParams = new java.util.HashMap<String, String>();

        java.util.Map<String, Object> localVarFormParams = new java.util.HashMap<String, Object>();

        final String[] localVarAccepts = {
            "text/plain"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call workloadResultGetValidateBeforeCall(String taskId, String workloadType, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'taskId' is set
        if (taskId == null) {
            throw new ApiException("Missing the required parameter 'taskId' when calling workloadResultGet(Async)");
        }
        
        // verify the required parameter 'workloadType' is set
        if (workloadType == null) {
            throw new ApiException("Missing the required parameter 'workloadType' when calling workloadResultGet(Async)");
        }
        

        com.squareup.okhttp.Call call = workloadResultGetCall(taskId, workloadType, progressListener, progressRequestListener);
        return call;

    }

    /**
     * get the result file of a workload task
     * Start a YCSB for the specified database 
     * @param taskId the id of the worklaod execution task, used as prefix for result files (required)
     * @param workloadType workload type of the result file (required)
     * @return File
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public File workloadResultGet(String taskId, String workloadType) throws ApiException {
        ApiResponse<File> resp = workloadResultGetWithHttpInfo(taskId, workloadType);
        return resp.getData();
    }

    /**
     * get the result file of a workload task
     * Start a YCSB for the specified database 
     * @param taskId the id of the worklaod execution task, used as prefix for result files (required)
     * @param workloadType workload type of the result file (required)
     * @return ApiResponse&lt;File&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<File> workloadResultGetWithHttpInfo(String taskId, String workloadType) throws ApiException {
        com.squareup.okhttp.Call call = workloadResultGetValidateBeforeCall(taskId, workloadType, null, null);
        Type localVarReturnType = new TypeToken<File>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * get the result file of a workload task (asynchronously)
     * Start a YCSB for the specified database 
     * @param taskId the id of the worklaod execution task, used as prefix for result files (required)
     * @param workloadType workload type of the result file (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call workloadResultGetAsync(String taskId, String workloadType, final ApiCallback<File> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = workloadResultGetValidateBeforeCall(taskId, workloadType, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<File>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for workloadStatusGet
     * @param applicationInstanceId the applicationInstanceI of the deployed DB cluster via Cloudiator (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call workloadStatusGetCall(String applicationInstanceId, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;

        // create path and map variables
        String localVarPath = "/workload/status";

        java.util.List<Pair> localVarQueryParams = new java.util.ArrayList<Pair>();
        java.util.List<Pair> localVarCollectionQueryParams = new java.util.ArrayList<Pair>();
        if (applicationInstanceId != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("applicationInstanceId", applicationInstanceId));

        java.util.Map<String, String> localVarHeaderParams = new java.util.HashMap<String, String>();

        java.util.Map<String, Object> localVarFormParams = new java.util.HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call workloadStatusGetValidateBeforeCall(String applicationInstanceId, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        

        com.squareup.okhttp.Call call = workloadStatusGetCall(applicationInstanceId, progressListener, progressRequestListener);
        return call;

    }

    /**
     * get the current state of the workloadProcess
     * Start a YCSB for the specified database 
     * @param applicationInstanceId the applicationInstanceI of the deployed DB cluster via Cloudiator (optional)
     * @return WorkloadProcessInstance
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public WorkloadProcessInstance workloadStatusGet(String applicationInstanceId) throws ApiException {
        ApiResponse<WorkloadProcessInstance> resp = workloadStatusGetWithHttpInfo(applicationInstanceId);
        return resp.getData();
    }

    /**
     * get the current state of the workloadProcess
     * Start a YCSB for the specified database 
     * @param applicationInstanceId the applicationInstanceI of the deployed DB cluster via Cloudiator (optional)
     * @return ApiResponse&lt;WorkloadProcessInstance&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<WorkloadProcessInstance> workloadStatusGetWithHttpInfo(String applicationInstanceId) throws ApiException {
        com.squareup.okhttp.Call call = workloadStatusGetValidateBeforeCall(applicationInstanceId, null, null);
        Type localVarReturnType = new TypeToken<WorkloadProcessInstance>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * get the current state of the workloadProcess (asynchronously)
     * Start a YCSB for the specified database 
     * @param applicationInstanceId the applicationInstanceI of the deployed DB cluster via Cloudiator (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call workloadStatusGetAsync(String applicationInstanceId, final ApiCallback<WorkloadProcessInstance> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = workloadStatusGetValidateBeforeCall(applicationInstanceId, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<WorkloadProcessInstance>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for workloadTpccPost
     * @param taskId the id of the worklaod execution task, used as prefix for result files (required)
     * @param workload the TPC-C workload configuration (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call workloadTpccPostCall(String taskId, TPCCWorkload workload, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = workload;

        // create path and map variables
        String localVarPath = "/workload/tpcc";

        java.util.List<Pair> localVarQueryParams = new java.util.ArrayList<Pair>();
        java.util.List<Pair> localVarCollectionQueryParams = new java.util.ArrayList<Pair>();
        if (taskId != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("taskId", taskId));

        java.util.Map<String, String> localVarHeaderParams = new java.util.HashMap<String, String>();

        java.util.Map<String, Object> localVarFormParams = new java.util.HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call workloadTpccPostValidateBeforeCall(String taskId, TPCCWorkload workload, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'taskId' is set
        if (taskId == null) {
            throw new ApiException("Missing the required parameter 'taskId' when calling workloadTpccPost(Async)");
        }
        
        // verify the required parameter 'workload' is set
        if (workload == null) {
            throw new ApiException("Missing the required parameter 'workload' when calling workloadTpccPost(Async)");
        }
        

        com.squareup.okhttp.Call call = workloadTpccPostCall(taskId, workload, progressListener, progressRequestListener);
        return call;

    }

    /**
     * starts a TPC-C workload against a relational DBMS
     * Start a TPC-C worklaod for the specified database based on the TPC-C implementation of cockroachdb 
     * @param taskId the id of the worklaod execution task, used as prefix for result files (required)
     * @param workload the TPC-C workload configuration (required)
     * @return WorkloadProcessInstance
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public WorkloadProcessInstance workloadTpccPost(String taskId, TPCCWorkload workload) throws ApiException {
        ApiResponse<WorkloadProcessInstance> resp = workloadTpccPostWithHttpInfo(taskId, workload);
        return resp.getData();
    }

    /**
     * starts a TPC-C workload against a relational DBMS
     * Start a TPC-C worklaod for the specified database based on the TPC-C implementation of cockroachdb 
     * @param taskId the id of the worklaod execution task, used as prefix for result files (required)
     * @param workload the TPC-C workload configuration (required)
     * @return ApiResponse&lt;WorkloadProcessInstance&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<WorkloadProcessInstance> workloadTpccPostWithHttpInfo(String taskId, TPCCWorkload workload) throws ApiException {
        com.squareup.okhttp.Call call = workloadTpccPostValidateBeforeCall(taskId, workload, null, null);
        Type localVarReturnType = new TypeToken<WorkloadProcessInstance>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * starts a TPC-C workload against a relational DBMS (asynchronously)
     * Start a TPC-C worklaod for the specified database based on the TPC-C implementation of cockroachdb 
     * @param taskId the id of the worklaod execution task, used as prefix for result files (required)
     * @param workload the TPC-C workload configuration (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call workloadTpccPostAsync(String taskId, TPCCWorkload workload, final ApiCallback<WorkloadProcessInstance> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = workloadTpccPostValidateBeforeCall(taskId, workload, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<WorkloadProcessInstance>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for workloadTsbsExecuteQueriesPost
     * @param taskId the id of the workload execution task, used as prefix for result files (required)
     * @param workload the TSBS workload configuration (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call workloadTsbsExecuteQueriesPostCall(String taskId, TSBSWorkload workload, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = workload;

        // create path and map variables
        String localVarPath = "/workload/tsbs/executeQueries";

        java.util.List<Pair> localVarQueryParams = new java.util.ArrayList<Pair>();
        java.util.List<Pair> localVarCollectionQueryParams = new java.util.ArrayList<Pair>();
        if (taskId != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("taskId", taskId));

        java.util.Map<String, String> localVarHeaderParams = new java.util.HashMap<String, String>();

        java.util.Map<String, Object> localVarFormParams = new java.util.HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call workloadTsbsExecuteQueriesPostValidateBeforeCall(String taskId, TSBSWorkload workload, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'taskId' is set
        if (taskId == null) {
            throw new ApiException("Missing the required parameter 'taskId' when calling workloadTsbsExecuteQueriesPost(Async)");
        }
        
        // verify the required parameter 'workload' is set
        if (workload == null) {
            throw new ApiException("Missing the required parameter 'workload' when calling workloadTsbsExecuteQueriesPost(Async)");
        }
        

        com.squareup.okhttp.Call call = workloadTsbsExecuteQueriesPostCall(taskId, workload, progressListener, progressRequestListener);
        return call;

    }

    /**
     * executes TSBS queries based on the loaded data
     * Execute queries 
     * @param taskId the id of the workload execution task, used as prefix for result files (required)
     * @param workload the TSBS workload configuration (required)
     * @return WorkloadProcessInstance
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public WorkloadProcessInstance workloadTsbsExecuteQueriesPost(String taskId, TSBSWorkload workload) throws ApiException {
        ApiResponse<WorkloadProcessInstance> resp = workloadTsbsExecuteQueriesPostWithHttpInfo(taskId, workload);
        return resp.getData();
    }

    /**
     * executes TSBS queries based on the loaded data
     * Execute queries 
     * @param taskId the id of the workload execution task, used as prefix for result files (required)
     * @param workload the TSBS workload configuration (required)
     * @return ApiResponse&lt;WorkloadProcessInstance&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<WorkloadProcessInstance> workloadTsbsExecuteQueriesPostWithHttpInfo(String taskId, TSBSWorkload workload) throws ApiException {
        com.squareup.okhttp.Call call = workloadTsbsExecuteQueriesPostValidateBeforeCall(taskId, workload, null, null);
        Type localVarReturnType = new TypeToken<WorkloadProcessInstance>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * executes TSBS queries based on the loaded data (asynchronously)
     * Execute queries 
     * @param taskId the id of the workload execution task, used as prefix for result files (required)
     * @param workload the TSBS workload configuration (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call workloadTsbsExecuteQueriesPostAsync(String taskId, TSBSWorkload workload, final ApiCallback<WorkloadProcessInstance> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = workloadTsbsExecuteQueriesPostValidateBeforeCall(taskId, workload, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<WorkloadProcessInstance>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for workloadTsbsGenerateDataPost
     * @param taskId the id of the workload execution task, used as prefix for result files (required)
     * @param workload the TSBS workload configuration (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call workloadTsbsGenerateDataPostCall(String taskId, TSBSWorkload workload, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = workload;

        // create path and map variables
        String localVarPath = "/workload/tsbs/generateData";

        java.util.List<Pair> localVarQueryParams = new java.util.ArrayList<Pair>();
        java.util.List<Pair> localVarCollectionQueryParams = new java.util.ArrayList<Pair>();
        if (taskId != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("taskId", taskId));

        java.util.Map<String, String> localVarHeaderParams = new java.util.HashMap<String, String>();

        java.util.Map<String, Object> localVarFormParams = new java.util.HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call workloadTsbsGenerateDataPostValidateBeforeCall(String taskId, TSBSWorkload workload, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'taskId' is set
        if (taskId == null) {
            throw new ApiException("Missing the required parameter 'taskId' when calling workloadTsbsGenerateDataPost(Async)");
        }
        
        // verify the required parameter 'workload' is set
        if (workload == null) {
            throw new ApiException("Missing the required parameter 'workload' when calling workloadTsbsGenerateDataPost(Async)");
        }
        

        com.squareup.okhttp.Call call = workloadTsbsGenerateDataPostCall(taskId, workload, progressListener, progressRequestListener);
        return call;

    }

    /**
     * generates the TSBS data
     * Generate data 
     * @param taskId the id of the workload execution task, used as prefix for result files (required)
     * @param workload the TSBS workload configuration (required)
     * @return WorkloadProcessInstance
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public WorkloadProcessInstance workloadTsbsGenerateDataPost(String taskId, TSBSWorkload workload) throws ApiException {
        ApiResponse<WorkloadProcessInstance> resp = workloadTsbsGenerateDataPostWithHttpInfo(taskId, workload);
        return resp.getData();
    }

    /**
     * generates the TSBS data
     * Generate data 
     * @param taskId the id of the workload execution task, used as prefix for result files (required)
     * @param workload the TSBS workload configuration (required)
     * @return ApiResponse&lt;WorkloadProcessInstance&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<WorkloadProcessInstance> workloadTsbsGenerateDataPostWithHttpInfo(String taskId, TSBSWorkload workload) throws ApiException {
        com.squareup.okhttp.Call call = workloadTsbsGenerateDataPostValidateBeforeCall(taskId, workload, null, null);
        Type localVarReturnType = new TypeToken<WorkloadProcessInstance>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * generates the TSBS data (asynchronously)
     * Generate data 
     * @param taskId the id of the workload execution task, used as prefix for result files (required)
     * @param workload the TSBS workload configuration (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call workloadTsbsGenerateDataPostAsync(String taskId, TSBSWorkload workload, final ApiCallback<WorkloadProcessInstance> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = workloadTsbsGenerateDataPostValidateBeforeCall(taskId, workload, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<WorkloadProcessInstance>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for workloadTsbsGenerateQueriesPost
     * @param taskId the id of the workload execution task, used as prefix for result files (required)
     * @param workload the TSBS workload configuration (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call workloadTsbsGenerateQueriesPostCall(String taskId, TSBSWorkload workload, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = workload;

        // create path and map variables
        String localVarPath = "/workload/tsbs/generateQueries";

        java.util.List<Pair> localVarQueryParams = new java.util.ArrayList<Pair>();
        java.util.List<Pair> localVarCollectionQueryParams = new java.util.ArrayList<Pair>();
        if (taskId != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("taskId", taskId));

        java.util.Map<String, String> localVarHeaderParams = new java.util.HashMap<String, String>();

        java.util.Map<String, Object> localVarFormParams = new java.util.HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call workloadTsbsGenerateQueriesPostValidateBeforeCall(String taskId, TSBSWorkload workload, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'taskId' is set
        if (taskId == null) {
            throw new ApiException("Missing the required parameter 'taskId' when calling workloadTsbsGenerateQueriesPost(Async)");
        }
        
        // verify the required parameter 'workload' is set
        if (workload == null) {
            throw new ApiException("Missing the required parameter 'workload' when calling workloadTsbsGenerateQueriesPost(Async)");
        }
        

        com.squareup.okhttp.Call call = workloadTsbsGenerateQueriesPostCall(taskId, workload, progressListener, progressRequestListener);
        return call;

    }

    /**
     * generates the TSBS quires in the DBMS-specific format
     * Generate TSBS queries 
     * @param taskId the id of the workload execution task, used as prefix for result files (required)
     * @param workload the TSBS workload configuration (required)
     * @return WorkloadProcessInstance
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public WorkloadProcessInstance workloadTsbsGenerateQueriesPost(String taskId, TSBSWorkload workload) throws ApiException {
        ApiResponse<WorkloadProcessInstance> resp = workloadTsbsGenerateQueriesPostWithHttpInfo(taskId, workload);
        return resp.getData();
    }

    /**
     * generates the TSBS quires in the DBMS-specific format
     * Generate TSBS queries 
     * @param taskId the id of the workload execution task, used as prefix for result files (required)
     * @param workload the TSBS workload configuration (required)
     * @return ApiResponse&lt;WorkloadProcessInstance&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<WorkloadProcessInstance> workloadTsbsGenerateQueriesPostWithHttpInfo(String taskId, TSBSWorkload workload) throws ApiException {
        com.squareup.okhttp.Call call = workloadTsbsGenerateQueriesPostValidateBeforeCall(taskId, workload, null, null);
        Type localVarReturnType = new TypeToken<WorkloadProcessInstance>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * generates the TSBS quires in the DBMS-specific format (asynchronously)
     * Generate TSBS queries 
     * @param taskId the id of the workload execution task, used as prefix for result files (required)
     * @param workload the TSBS workload configuration (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call workloadTsbsGenerateQueriesPostAsync(String taskId, TSBSWorkload workload, final ApiCallback<WorkloadProcessInstance> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = workloadTsbsGenerateQueriesPostValidateBeforeCall(taskId, workload, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<WorkloadProcessInstance>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for workloadTsbsLoadDataPost
     * @param taskId the id of the workload execution task, used as prefix for result files (required)
     * @param workload the TSBS workload configuration (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call workloadTsbsLoadDataPostCall(String taskId, TSBSWorkload workload, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = workload;

        // create path and map variables
        String localVarPath = "/workload/tsbs/loadData";

        java.util.List<Pair> localVarQueryParams = new java.util.ArrayList<Pair>();
        java.util.List<Pair> localVarCollectionQueryParams = new java.util.ArrayList<Pair>();
        if (taskId != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("taskId", taskId));

        java.util.Map<String, String> localVarHeaderParams = new java.util.HashMap<String, String>();

        java.util.Map<String, Object> localVarFormParams = new java.util.HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call workloadTsbsLoadDataPostValidateBeforeCall(String taskId, TSBSWorkload workload, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'taskId' is set
        if (taskId == null) {
            throw new ApiException("Missing the required parameter 'taskId' when calling workloadTsbsLoadDataPost(Async)");
        }
        
        // verify the required parameter 'workload' is set
        if (workload == null) {
            throw new ApiException("Missing the required parameter 'workload' when calling workloadTsbsLoadDataPost(Async)");
        }
        

        com.squareup.okhttp.Call call = workloadTsbsLoadDataPostCall(taskId, workload, progressListener, progressRequestListener);
        return call;

    }

    /**
     * loads the data in the specified timeseries DBMS
     * Load data 
     * @param taskId the id of the workload execution task, used as prefix for result files (required)
     * @param workload the TSBS workload configuration (required)
     * @return WorkloadProcessInstance
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public WorkloadProcessInstance workloadTsbsLoadDataPost(String taskId, TSBSWorkload workload) throws ApiException {
        ApiResponse<WorkloadProcessInstance> resp = workloadTsbsLoadDataPostWithHttpInfo(taskId, workload);
        return resp.getData();
    }

    /**
     * loads the data in the specified timeseries DBMS
     * Load data 
     * @param taskId the id of the workload execution task, used as prefix for result files (required)
     * @param workload the TSBS workload configuration (required)
     * @return ApiResponse&lt;WorkloadProcessInstance&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<WorkloadProcessInstance> workloadTsbsLoadDataPostWithHttpInfo(String taskId, TSBSWorkload workload) throws ApiException {
        com.squareup.okhttp.Call call = workloadTsbsLoadDataPostValidateBeforeCall(taskId, workload, null, null);
        Type localVarReturnType = new TypeToken<WorkloadProcessInstance>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * loads the data in the specified timeseries DBMS (asynchronously)
     * Load data 
     * @param taskId the id of the workload execution task, used as prefix for result files (required)
     * @param workload the TSBS workload configuration (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call workloadTsbsLoadDataPostAsync(String taskId, TSBSWorkload workload, final ApiCallback<WorkloadProcessInstance> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = workloadTsbsLoadDataPostValidateBeforeCall(taskId, workload, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<WorkloadProcessInstance>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for workloadYcsbPost
     * @param taskId the id of the worklaod execution task, used as prefix for result files (required)
     * @param workload the YCSB workload configuration (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call workloadYcsbPostCall(String taskId, YCSBWorkload workload, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = workload;

        // create path and map variables
        String localVarPath = "/workload/ycsb";

        java.util.List<Pair> localVarQueryParams = new java.util.ArrayList<Pair>();
        java.util.List<Pair> localVarCollectionQueryParams = new java.util.ArrayList<Pair>();
        if (taskId != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("taskId", taskId));

        java.util.Map<String, String> localVarHeaderParams = new java.util.HashMap<String, String>();

        java.util.Map<String, Object> localVarFormParams = new java.util.HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call workloadYcsbPostValidateBeforeCall(String taskId, YCSBWorkload workload, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'taskId' is set
        if (taskId == null) {
            throw new ApiException("Missing the required parameter 'taskId' when calling workloadYcsbPost(Async)");
        }
        
        // verify the required parameter 'workload' is set
        if (workload == null) {
            throw new ApiException("Missing the required parameter 'workload' when calling workloadYcsbPost(Async)");
        }
        

        com.squareup.okhttp.Call call = workloadYcsbPostCall(taskId, workload, progressListener, progressRequestListener);
        return call;

    }

    /**
     * start a YCSB workload against the provided database
     * Start a YCSB for the specified database 
     * @param taskId the id of the worklaod execution task, used as prefix for result files (required)
     * @param workload the YCSB workload configuration (required)
     * @return WorkloadProcessInstance
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public WorkloadProcessInstance workloadYcsbPost(String taskId, YCSBWorkload workload) throws ApiException {
        ApiResponse<WorkloadProcessInstance> resp = workloadYcsbPostWithHttpInfo(taskId, workload);
        return resp.getData();
    }

    /**
     * start a YCSB workload against the provided database
     * Start a YCSB for the specified database 
     * @param taskId the id of the worklaod execution task, used as prefix for result files (required)
     * @param workload the YCSB workload configuration (required)
     * @return ApiResponse&lt;WorkloadProcessInstance&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<WorkloadProcessInstance> workloadYcsbPostWithHttpInfo(String taskId, YCSBWorkload workload) throws ApiException {
        com.squareup.okhttp.Call call = workloadYcsbPostValidateBeforeCall(taskId, workload, null, null);
        Type localVarReturnType = new TypeToken<WorkloadProcessInstance>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * start a YCSB workload against the provided database (asynchronously)
     * Start a YCSB for the specified database 
     * @param taskId the id of the worklaod execution task, used as prefix for result files (required)
     * @param workload the YCSB workload configuration (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call workloadYcsbPostAsync(String taskId, YCSBWorkload workload, final ApiCallback<WorkloadProcessInstance> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = workloadYcsbPostValidateBeforeCall(taskId, workload, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<WorkloadProcessInstance>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
}
